package me.yoqi.android.appmanager;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import me.yoqi.android.appmanager.model.AppInfo;
import me.yoqi.android.appmanager.model.AppModel;
import me.yoqi.android.appmanager.views.AppInfoAdapter;
import me.yoqi.android.utils.SPUtils;
import me.yoqi.android.utils.SimplexToast;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    public static final String TAG = "MainActivity";
    RadioButton allApp, dsfApp;
    ListView listView;
    TextView tvLoad;

    AppInfoAdapter adapter;
    List<AppInfo> mdatas = new ArrayList<>();
    List<AppInfo> appInfos = new ArrayList<>();
    List<AppInfo> dsfappInfos = new ArrayList<>();
    Context mContext;
    SimplexToast simplexToast;
    SPUtils spUtils;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mContext = this;
        initView();
        initData();
    }

    private void initView() {
        allApp = findViewById(R.id.allApp); //所有app
        dsfApp = findViewById(R.id.dsfApp); //第三方app
        tvLoad = findViewById(R.id.tvLoad); //加载中。。。
        listView = findViewById(R.id.listView);
        allApp.setOnClickListener(this);
        dsfApp.setOnClickListener(this);
        simplexToast = new SimplexToast(mContext);
        spUtils = new SPUtils(mContext);
    }

    private void initData() {
        Set<String> pkgs = spUtils.getStringSet("hide_app", null);
        // 构建适配器，并且注册到listView
        adapter = new AppInfoAdapter(this, mdatas);
        listView.setAdapter(adapter);
        new Thread(new Runnable() {
            @Override
            public void run() {
                appInfos = AppModel.queryFilterAppInfo(mContext, AppModel.FILTER_SYSTEM_APP);
                dsfappInfos = AppModel.queryFilterAppInfo(mContext, AppModel.FILTER_THIRD_APP);
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        mdatas.addAll(appInfos);
                        adapter.notifyDataSetChanged();
                        tvLoad.setVisibility(View.GONE);
                        listView.setVisibility(View.VISIBLE);
                    }
                });
            }
        }).start();

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.allApp:
                mdatas.clear();
                mdatas.addAll(appInfos);
                adapter.notifyDataSetChanged();
                break;
            case R.id.dsfApp:
                mdatas.clear();
                mdatas.addAll(dsfappInfos);
                adapter.notifyDataSetChanged();
                break;
        }
    }
}